package be.ac.umons.ProjetInfo.BAC1.CharlierDucruet.game;
import be.ac.umons.ProjetInfo.BAC1.CharlierDucruet.listener.*;
import be.ac.umons.ProjetInfo.BAC1.CharlierDucruet.geom.*;
import be.ac.umons.ProjetInfo.BAC1.CharlierDucruet.gui.*;
import be.ac.umons.ProjetInfo.BAC1.CharlierDucruet.*;

import java.awt.Polygon;
import java.awt.geom.Point2D;
import java.awt.Graphics;
import java.awt.Color;
import java.awt.Image;
import java.awt.geom.AffineTransform;
import java.awt.Graphics2D;
public class Burst extends Moving implements IDrawable
{
    public static final double DIAGONALSIZE = 69.31; // taille de la diagonale de l'image
    public static final double TLIFE = 3000; //temps de l'explosion
    public static final double RMAX = 50; //le rayon max de l'explosion
    private double radius, sizePourcent; 
    
    /**
    * @param pos la posision de l'explosion
    * @param r un rayon maximum pour l'explosion
    */
    public Burst(Point2D.Double pos, double r)
    {
        super(pos, TLIFE);
        radius = r;
    }
    
    /**
    *   Mets  jours la position sans modulo
    */
    public void refreshPosition()
    {
        refreshPosition(false);
    }
    
    /**
    * Dssine une explosion  l'cran.
    */
    public void draw(Graphics g)
    {
        sizePourcent = getSizeLife();      
        Graphics2D g2 = (Graphics2D) g;
        AffineTransform at = new AffineTransform();
        // on calcule le point superieur gauche de l'image
        Point2D.Double pCorner = Geom.translate(getPos(), Geom.normalize(Geom.rotate(getOrien(), -133.8), getRadius()));
        at = new AffineTransform();
        at.translate(pCorner.getX() * Config.getFrameRate(), pCorner.getY() * Config.getFrameRate());
        // on tourne de l'orientation de v orient + de l'angle du canon
        at.rotate(Math.toRadians(Geom.angle(getOrien())));
        at.scale(sizePourcent * Config.getFrameRate(), sizePourcent * Config.getFrameRate());
        g2.drawImage(Engine.images.burst, at, null);
        
        /* Pour ne pas avoir un jeu static en pause, on a dessid de tourner les explosion  chaque repaint */
        setOrien(Geom.rotate(getOrien(), Config.getTurnFactor() * 2)); 
    }
    
    /**
    * @return la longeur de la diagonale de l'explosion
    */
    public double getRadius()
    {
        return DIAGONALSIZE * sizePourcent;
    }
    
    /**
    * @return la propostion de la taille de l'image par apport au temps
    */
    private double getSizeLife()
    {
        
        return ( 1 - (getLifeTime() / TLIFE)) * (radius / RMAX);
    
    }
    
        
    /**
    * @return si l'explosion peut-tre dessin dans la zone centrale du jeu.
    */
    public boolean isIDrawable()
    {
        return (( Geom.distance(getPos(), Config.getPCenter()) - getRadius() ) <= Config.getDistancePrintMobile() );
    }
    
}