package be.ac.umons.ProjetInfo.BAC1.CharlierDucruet.game;
import be.ac.umons.ProjetInfo.BAC1.CharlierDucruet.listener.*;
import be.ac.umons.ProjetInfo.BAC1.CharlierDucruet.geom.*;
import be.ac.umons.ProjetInfo.BAC1.CharlierDucruet.gui.*;
import be.ac.umons.ProjetInfo.BAC1.CharlierDucruet.*;

import java.awt.geom.Point2D;
import java.awt.Graphics;
import java.awt.Color;
import java.awt.Graphics2D;
import javax.swing.JPanel;
import java.awt.geom.AffineTransform;
public class Missile extends Moving implements IDrawable
{    
    static final int IHEIGHT = 15, IWIDTH = 8, SIZE = 10; //taille de l'image
    static final double TLIFE = 4000; //les missiles ont 4secondes de vie
    /**
     * Constructeur d'un objet Missile.
     * @param pPos un point: la position du missile.
     * @param vDirect un vecteur: la direction du missile.
     * @param speed la vitesse du missile.
     */
    public Missile(Point2D.Double pPos, Point2D.Double vDirect, double speed)
    {
       super(pPos, vDirect, speed);
        setTimeToDead(TLIFE);
    }
    
    /**
     *  Permet de dessiner un Missile.
     */
    public void draw(Graphics g)
    {
        if (isIDrawable())
        {
            // g.setColor(Color.green);
            // g.fillOval((int)getPos().getX(), (int)getPos().getY(), 2, 2);
            
            Graphics2D g2 =(Graphics2D) g;
            AffineTransform at = new AffineTransform();
            Point2D.Double v = Geom.inverseVector(getOrien());
            Point2D.Double pCorner = Geom.translate(getPos(),Geom.normalize(Geom.rotate(v, 90),3));
            at.translate(pCorner.getX() * Config.getFrameRate(), pCorner.getY() * Config.getFrameRate());
            at.rotate(Math.toRadians(Geom.angle(getOrien())+90));
            at.scale(Config.getFrameRate(), Config.getFrameRate());
            g2.drawImage(Engine.images.missile, at, null);
        }
    }
    
    /**
    * @return si le missile peut-être dessiné dans la zone centrale du jeu.
    */
    public boolean isIDrawable()
    {
        return Geom.distance(getPos(), Config.getPCenter()) + getSize() < Config.getDistancePrintMobile();
    }
    
    /**
    * @return la longeur du missile (longeur de leur image).
    */
    public static int getSize()
    {
        return SIZE;
    }
    
}