package be.ac.umons.ProjetInfo.BAC1.CharlierDucruet.gui;
import be.ac.umons.ProjetInfo.BAC1.CharlierDucruet.geom.*;
import be.ac.umons.ProjetInfo.BAC1.CharlierDucruet.game.*;
import be.ac.umons.ProjetInfo.BAC1.CharlierDucruet.*;

import java.awt.Graphics;
import java.awt.Color;
import java.awt.Font;
import java.awt.Graphics2D;
import java.awt.geom.AffineTransform;
import java.awt.Image;
import java.awt.geom.Point2D;

public class GuiEvent
{
    private static GameOver  gameOver= new GameOver();
    private static NewGame newGame = new NewGame();
    private static HelpControl helpControl = new HelpControl();
    private static HelpInterface helpInterface = new HelpInterface();
    private static HelpBonus helpBonus = new HelpBonus();
    private static HelpGame helpGame = new HelpGame();
    private static BreackGame breackGame = new BreackGame();
    private static BackGroundGradation backGroundGradadion = new BackGroundGradation();
    public static final Color GREEN = new Color(51, 153, 51);
    public static final String FONT = "Verdanna";
    
    
    /**
    * Permet l'affichage de l'cran de game over.
    * Affiche le niveau atteind, la difficulte choisi et le score obtenu.
    */
    public static class GameOver implements IDrawable
    {
        public void draw(Graphics g)
        {
            //Affichage image de gameover
            Graphics2D g2d = (Graphics2D) g;
            AffineTransform at = new AffineTransform();
            at.translate((Config.getPCenter().getX() - 215) * Config.getFrameRate(), (Config.getPCenter().getY() - 75) * Config.getFrameRate());
            at.scale(Config.getFrameRate(), Config.getFrameRate());
            g2d.drawImage(Engine.images.menuGameOver, at, null);

            int fontSize = (int) ( 20 * Config.getFrameRate());
            g.setFont(new Font(FONT, Font.PLAIN, fontSize));
            g.setColor(GREEN); // vert

            String output = "Avec un score de " + Engine.getScore() +".";
            g.drawString(output, (int) (325 * Config.getFrameRate()), (int) (416 * Config.getFrameRate()));            
            output = "En difficult " + Config.getDifficultiString() +".";
            g.drawString(output, (int) (325 * Config.getFrameRate()), (int) (436 * Config.getFrameRate()));      
            output = "Vous tiez au niveau " + Engine.getLevel() + ".";
            g.drawString(output, (int) (325 * Config.getFrameRate()), (int) (456 * Config.getFrameRate()));
        }        
    }
    
    /** Page d'acceuille du jeu */
    public static class NewGame implements IDrawable
    {
        public void draw(Graphics g)
        {
            int fontSize = (int) ( 25 * Config.getFrameRate());
            g.setFont(new Font(FONT, Font.PLAIN, fontSize));
            g.setColor(GREEN); // vert

            Graphics2D g2d = (Graphics2D) g;
            AffineTransform at = new AffineTransform();
            at.scale(Config.getFrameRate(), Config.getFrameRate());
            g2d.drawImage(Engine.images.menuTitle, at, null);
            
            g.drawString("Veuillez crer une nouvelle partie.",(int) (258 * Config.getFrameRate()), (int) (465 * Config.getFrameRate()));
            
            g.drawString("Projets d'informatique.",(int) (327 * Config.getFrameRate()), (int) (593 * Config.getFrameRate()));
            g.drawString("UMONS 2013,",(int) (374 * Config.getFrameRate()), (int) (627 * Config.getFrameRate()));
            g.drawString("Corentin Ducruet - Maximilien Charlier.",(int) (242 * Config.getFrameRate()), (int) (655 * Config.getFrameRate()));
        }        
    }
    
    /** Affiche une lgende pour les touches du clavier */
    public static class HelpControl implements IDrawable
    {
        public void draw(Graphics g)
        {
            // On dssine un fond semi-transparant.
            drawBackgroundBlack80(g);
            
            
            //Affichage image "commandes"
            Graphics2D g2d = (Graphics2D) g;
            AffineTransform at = new AffineTransform();
            at.translate(240 * Config.getFrameRate(), 60 * Config.getFrameRate());
            at.scale(Config.getFrameRate(), Config.getFrameRate());
            g2d.drawImage(Engine.images.helpControl, at, null);
            

            //Touche en rapport avec le game play
            String[] texte = {"Z", "Q", "D", "S", "Espace et clic", "B", "La souris"};
            drawTabString(g, texte, new Point2D.Double(100, 180), 20, 25);
            String[] texte2 = {"Avancer", "Tourner  gauche", "Tourner  droite", "Ralentir", "Tirer", "Bloquer le lance missile vers la pointe du vaisseau", "Pour viser"};
            drawTabString(g, texte2, new Point2D.Double(250, 180), 20, 25);          

            String[] texte3 = {"P", "N", "ESC"};
            drawTabString(g, texte3, new Point2D.Double(200, 475), 20, 25);
            String[] texte4 = {"Faire pause.", "Cre une nouvelle partie (difficult courante de base \"Moyenne\").", "Fermer le jeu."};
            
            drawTabString(g, texte4, new Point2D.Double(250, 475), 20, 25);
        }        
    }
    
    /** Affiche une lgende pour les bonus */
    public static class HelpBonus implements IDrawable
    {
        public void draw(Graphics g)
        {
            // On dssine un fond semi-transparant.
            drawBackgroundBlack80(g);
            
            
            //Affichage image "Bonus"
            Graphics2D g2d = (Graphics2D) g;
            AffineTransform at = new AffineTransform();
            at.translate(300 * Config.getFrameRate(), 60 * Config.getFrameRate());
            at.scale(Config.getFrameRate(), Config.getFrameRate());
            g2d.drawImage(Engine.images.helpBonus, at, null);

            int fontSize = (int) ( 20 * Config.getFrameRate());
            g.setFont(new Font(FONT, Font.PLAIN, fontSize));
            g.setColor(GREEN); // vert
            
            //on affiche les images des differents bonus.
            drawImBonus(g2d);
            
            
            String[] texte = {"Bonus vie: permet de rajouter de la vie au vaisseau.", "Bonus division: permet de diviser les asterodes en rcuprant le score.", "Malus division: permet de diviser les asterodes sans rcuprer le score.", "Bonus invincibilit: permet d'tre insensible au collision.", "Bonus radar: permet d'amliorer la prcision du radar.", "Malus radar: le radar est dsactiv pendant un certain temps.", "Malus tlportation: tlporte le vaisseau alatoirement sur la carte.", "Bonus temps: rajoute du temps.", "Malus temprature : votre canon surchauffe.", "Bonus temprature : votre canon est totalement refroidi." };
            drawTabString(g, texte, new Point2D.Double(200, 180), 20, 50);            
        }        
    }
    
    /** Affiche l'aide concernant l'interface du jeu */
    public static class HelpInterface implements IDrawable
    {
        public void draw(Graphics g)
        {
            // On dssine un fond semi-transparant.
            drawBackgroundBlack80(g);
            
            
            //Affichage image "Interface"
            Graphics2D g2d = (Graphics2D) g;
            AffineTransform at = new AffineTransform();
            /* On va choisir l'image en fonction de la rsolution de l'cran.*/
            int i = 2;
            if (Main.getDisplay().getWidth() == 450)
                i = 0;
            else if (Main.getDisplay().getWidth() == 600)
                i = 1;
            else if (Main.getDisplay().getWidth() == 800)
                i = 2;
            else if (Main.getDisplay().getWidth() == 900)
                i = 3;
            else
                i = 4;
            g2d.drawImage(Engine.images.helpInterface[i], at, null);            
        }        
    }     
    
    /** Affichage de l'aide donnant le but du jeu. */
    public static class HelpGame implements IDrawable
    {
        public void draw(Graphics g)
        {
            // On dssine un fond semi-transparant.
            drawBackgroundBlack80(g);
            
            
            //Affichage image "Interface"
            Graphics2D g2d = (Graphics2D) g;
            AffineTransform at = new AffineTransform();
            at.translate(240 * Config.getFrameRate(), 60 * Config.getFrameRate());
            at.scale(Config.getFrameRate(), Config.getFrameRate());
            g2d.drawImage(Engine.images.helpGame, at, null);
            
            // texte

            String[] texte = {"L'objectif principal du jeu est de capturer les astronautes perdus dans l'espace.", "Faites attention  votre barre de vie et au temps restant pour le niveau.", " chaque fin de niveau vous rcuprez une partie de votre vie et vous gagnez", " un bonus invincibilit.", "", "Vous avez la possibilit de mettre le jeu en pause !", "Profitez en pour vous informez sur la distance  laquelle vous tes", "des astronautes.", "", "Faites aussi attention  la temprature de votre canon !"};
            drawTabString(g, texte, new Point2D.Double(60, 240), 18, 35) ;          
        }        
    }    
    
    /** Affiche que le jeu est en pause.*/
    public static class BreackGame implements IDrawable
    {
        public void draw(Graphics g)
        {
            //Affichage image de gameover
            Graphics2D g2d = (Graphics2D) g;
            AffineTransform at = new AffineTransform();
            at.translate((Config.getPCenter().getX() - 150) * Config.getFrameRate(), (Config.getPCenter().getY() - 75) * Config.getFrameRate());
            at.scale(Config.getFrameRate(), Config.getFrameRate());
            g2d.drawImage(Engine.images.menuBreackGame, at, null);
        }        
    }
    
    /** Font dgrad qui fait la transition entre les couches de l'affichage du jeu */
    public static class BackGroundGradation implements IDrawable
    {
        public void draw(Graphics g)
        {
            //dessine le fond de la fentre
            Graphics2D g2d = (Graphics2D) g;
            AffineTransform at = new AffineTransform();
            at.scale(Config.getFrameRate(), Config.getFrameRate());
            g2d.drawImage(Engine.images.backGroundGradation, at, null);
        }
    }
    
    /**
     *
     */
    public static void drawImBonus(Graphics2D g2d)
    {
        int i = 0;
        int x = 150; //position en x
        int y = 150; //position en y
        AffineTransform at = new AffineTransform();
        while(i < Bonus.getNbBonus())
        {
            at = new AffineTransform();
            at.translate(x * Config.getFrameRate(), y * Config.getFrameRate());
            at.rotate(Math.toRadians(90));
            at.scale(Config.getFrameRate(), Config.getFrameRate());
            g2d.drawImage(Engine.images.bonus[i], at, null);
            i++;
            y+=50;
        }
    }
    
    /**
     * @return un objet GameOver pour l'affichage
     */
    public static GameOver getGameOver()
    {
        return gameOver;
    }
    
     /**
     * @return un objet NewGame pour l'affichage
     */
    public static NewGame getNewGame()
    {
        return newGame;
    }     
    
    /**
     * @return un objet BreackGame pour l'affichage
     */
    public static BreackGame getBreackGame()
    {
        return breackGame;
    } 
    
    /**
     * @return un objet dssinant le fond en dgrad.
     */
    public static BackGroundGradation getBackGroundGradation()
    {
        return backGroundGradadion;
    }
    
    /**
     * @return un objet HelpBonus pour l'affichage
     */
    public static HelpBonus getHelpBonus()
    {
        return helpBonus;
    }
    
    /**
     * @return un objet HelpGame pour l'affichage
     */
    public static HelpGame getHelpGame()
    {
        return helpGame;
    }
    
    /**
     * @return un objet HelpInterface pour l'affichage
     */
    public static HelpInterface getHelpInterface()
    {
        return helpInterface;
    }
    
    /**
     * @return un objet HelpControl pour l'affichage
     */
    public static HelpControl getHelpControl()
    {
        return helpControl;
    }
    
    /**
    *   Dssine un fond noir.
    */
    public static void drawBackgroundBlack(Graphics g)
    {
        g.setColor(Color.black);
        g.fillRect(0,0, Config.getFrameX(), Config.getFrameY());
    }    
    
    /**
    *   Dssine un fond noir  80 d'opacit.
    */
    public static void drawBackgroundBlack80(Graphics g)
    {
        //dessine le fond de la fentre
        Graphics2D g2d = (Graphics2D) g;
        AffineTransform at = new AffineTransform();
        at.scale(900 * Config.getFrameRate(), 720 * Config.getFrameRate());
        g2d.drawImage(Engine.images.backGroundBlack80, at, null);
    }
    
    /**
    * Permet d'afficher du texte  l'cran  partir d'un tableau de String.
    * Pour chaque nouvelle cellule du tableau il y aura un retour  la ligne.
    * @param texte le tableau contenant le texte
    * @param _fontSize la taille de la police
    * @param p La position du dbut du paragraphe
    * @param sizeLN La taille de retour  la ligne (Dcalage en hauteur) en pixel.
    * Le texte est en GREEN et en police FONT.
    * Prrequis : Avoir donn un style  g
    */
    public static void drawTabString(Graphics g, String[] texte, Point2D.Double p, int _fontSize, double sizeLN)
    {
        int fontSize = (int) ( _fontSize * Config.getFrameRate());
        g.setFont(new Font(FONT, Font.PLAIN, fontSize));
        g.setColor(GREEN); // vert

        int i = 0; // compte le nombre de retour  la ligne
        for (String t : texte)
        {
            if (t.length() > 0)
            {   //On vrifie que a contient du texte, (sinon a fait juste un retour  la ligne)
                g.drawString(t, (int) (p.getX() * Config.getFrameRate()), (int) ((p.getY() + sizeLN * i) * Config.getFrameRate()));
            }
            i++;
        }
    }
}