package be.ac.umons.ProjetInfo.BAC1.CharlierDucruet.gui;
import be.ac.umons.ProjetInfo.BAC1.CharlierDucruet.geom.*;
import be.ac.umons.ProjetInfo.BAC1.CharlierDucruet.game.*;
import be.ac.umons.ProjetInfo.BAC1.CharlierDucruet.*;


import javax.imageio.ImageIO;
import java.awt.Image;
import java.io.File;
import java.io.IOException;
public class ImageGame
{
    public Image asteroid;
    public Image spaceShip;
    public Image spaceShipInv;
    public Image missileLuncher;
    public Image missileLuncherGauge;
    public Image backGround;
    public Image backGroundGradation;
    public Image missile;
    public Image[] bonus = new Image[10];
    public Image astronaut;
    
    public Image menuTitle;
    public Image menuGameOver;
    public Image menuBreackGame;
    public Image helpControl;
    public Image[] helpInterface = new Image[5];
    public Image helpBonus;
    public Image helpGame;
    public Image backGroundBlack80;
    
    public Image transparentBlueSeedlings;
    public Image radarWave;
    public Image burst;
    public Image[] radarAstro = new Image[5];
    public static final String dir = "code/image/";
    
    /**
     * constructeur de ImageGame, s'occupe de charger les images.
     */
    public ImageGame()
    {
        try
        {
            backGround = ImageIO.read(new File(dir + "backGround.png"));
            backGroundGradation = ImageIO.read(new File(dir + "backGroundGradadion.png"));
            asteroid = ImageIO.read(new File(dir + "asteroids.png"));
            missile = ImageIO.read(new File(dir + "missile.png"));
            burst = ImageIO.read(new File(dir + "burst.png"));
            /* vie*/
            transparentBlueSeedlings = ImageIO.read(new File(dir + "transparentBlueSeedlings.png"));

            spaceShip = ImageIO.read(new File(dir + "spaceShip.png"));
            spaceShipInv = ImageIO.read(new File(dir + "spaceShipInv.png"));
            missileLuncher = ImageIO.read(new File(dir + "missileLuncher.png"));
            missileLuncherGauge = ImageIO.read(new File(dir + "missileLuncherGauge.png"));

            bonus[0] = ImageIO.read(new File(dir + "bonus-heart.png"));
            bonus[1] = ImageIO.read(new File(dir + "bonus-division.png"));
            bonus[2] = ImageIO.read(new File(dir + "malus-division.png"));
            bonus[3] = ImageIO.read(new File(dir + "bonus-invincibility.png")); 
            bonus[4] = ImageIO.read(new File(dir + "bonus-radar.png")); 
            bonus[5] = ImageIO.read(new File(dir + "malus-radar.png")); 
            bonus[6] = ImageIO.read(new File(dir + "malus-teleportation.png")); 
            bonus[7] = ImageIO.read(new File(dir + "bonus-time.png")); 
            bonus[8] = ImageIO.read(new File(dir + "malus-temperature.png")); 
            bonus[9] = ImageIO.read(new File(dir + "bonus-temperature.png")); 
            
            astronaut = ImageIO.read(new File(dir + "astronaut.png"));
             
            /*menu */
            menuTitle = ImageIO.read(new File(dir + "menuTitle.png"));
            menuGameOver = ImageIO.read(new File(dir + "menuGameOver.png"));
            menuBreackGame = ImageIO.read(new File(dir + "menuBreackGame.png"));
            helpInterface[0] = ImageIO.read(new File(dir + "helpInterface450x360.png"));
            helpInterface[1] = ImageIO.read(new File(dir + "helpInterface600x480.png"));
            helpInterface[2] = ImageIO.read(new File(dir + "helpInterface800x640.png"));
            helpInterface[3] = ImageIO.read(new File(dir + "helpInterface900x720.png"));
            helpInterface[4] = ImageIO.read(new File(dir + "helpInterface1100x880.png"));
            helpBonus = ImageIO.read(new File(dir + "helpBonus.png"));
            helpGame = ImageIO.read(new File(dir + "helpGame.png"));
            helpControl = ImageIO.read(new File(dir + "helpControl.png"));
            backGroundBlack80 = ImageIO.read(new File(dir + "background-black-80.png"));
            
            /*radar */
            radarAstro[0] = ImageIO.read(new File(dir + "astro-detect-20.png"));
            radarAstro[1] = ImageIO.read(new File(dir + "astro-detect-40.png"));
            radarAstro[2] = ImageIO.read(new File(dir + "astro-detect-60.png"));
            radarAstro[3] = ImageIO.read(new File(dir + "astro-detect-80.png"));
            radarAstro[4] = ImageIO.read(new File(dir + "astro-detect-100.png"));
            radarWave = ImageIO.read(new File(dir + "onde.png"));
        }
        catch(IOException e)
        {
            e.printStackTrace();
            System.out.println("Caught IOException!, Problme de lecture d'image.");
        }
    }
    
    /**
    * @param pourcent un pourcentage de luminosit pour l'affichage.
    * @return une image plus ou moins fonce en fct du temps
    */
    public Image getImageRadarAstro(double pourcent)
    {
        if (pourcent < 20)
            return radarAstro[0];
        else if (pourcent < 40)
            return radarAstro[1];
        else if (pourcent < 60)
            return radarAstro[2];
        else if (pourcent < 80)
            return radarAstro[3];
        else
            return radarAstro[4];
    }
}