package be.ac.umons.ProjetInfo.BAC1.CharlierDucruet.test;
import be.ac.umons.ProjetInfo.BAC1.CharlierDucruet.gui.*;
import be.ac.umons.ProjetInfo.BAC1.CharlierDucruet.geom.*;
import be.ac.umons.ProjetInfo.BAC1.CharlierDucruet.game.*;
import java.awt.geom.Point2D;
import java.awt.geom.Ellipse2D;
import static org.junit.Assert.*;
import org.junit.*;
import org.junit.Test;

public class ProjetTest
{
    public static void main(String[] args)
    {
        testGeom();
        testSpaceShip();
        testAsteroid();
        System.out.println("Test reussi");
    }

    
    /**
    * Test du radar
    */
    public static void testRadar()
    {   
        /*test de la fonction refresh
        
        les tests pour récupérer l'angle entre l'astronaute et le centre sont calculés dans les tests de Geom (fonction angle).
        
        le reste se fait à l'aide de simple accesseur*/
    }
    
    /**
     * Test de Asteroid.
     */
    @Test
    public static void testAsteroid()
    {        
        Point2D.Double pPos=new Point2D.Double(100,100);
        Point2D.Double vDirect= new Point2D.Double(50,50);
        Asteroid asteroid=new Asteroid(pPos,vDirect, 50);
        
        //Test de getPos
        assertTrue("getPos()", (pPos.equals(asteroid.getPos())));
        
        //Test de setPos
        Point2D.Double pPos1=new Point2D.Double (145,120);
        asteroid.setPos(pPos1);
        assertTrue("setPos(p)", (pPos1.equals(asteroid.getPos())));
        
        //Test de getRadius
        assertTrue("getRadius()", (30==asteroid.getRadius()));
        
        //Test de setRadius
        asteroid.setRadius(20);
        assertTrue("setRadius(i)", (20==asteroid.getRadius()));
        
        //Test de getSpeed
        assertTrue("getSpeed()", (50 == asteroid.getSpeed()));
        
        //Test de setSpeed
        asteroid.setSpeed(10);
        assertTrue("setSpeed(v)", (10 == asteroid.getSpeed()));
        
        //Test de equals
        Asteroid asteroid0=new Asteroid(pPos,vDirect, 50);
        Asteroid asteroid1=new Asteroid(pPos, vDirect, 50);
        Asteroid asteroid2=new Asteroid(pPos, vDirect,20);
        assertTrue("equals(Asteroid)", (asteroid0.equals(asteroid1)&& !asteroid1.equals(asteroid2)));//test l'inégalité et l'égalité
        
        
        //Test de asteroidToEllipse
        Ellipse2D.Double ellipse = new Ellipse2D.Double(3,3,10,10);
        Point2D.Double pPosEllipse=new Point2D.Double(8,8);
        Asteroid asteroidEllipse = new Asteroid(pPosEllipse,vDirect,50,5);
        assertTrue("asteroidToEllipse()", (asteroidEllipse.asteroidToEllipse().equals(ellipse)));
    }
    

    /**
    * Test du vaisseau
    */
    @Test
    public static void testSpaceShip()
    {        
        SpaceShip ship=new SpaceShip();

        
        
        //Test setDirect et getDirect
        Point2D.Double vDirection=new Point2D.Double(30,30);
        ship.setDirect(vDirection);
        assertTrue("setDirect(v) et getDirect()",(vDirection.equals(ship.getDirect())));
        
        //Test setOrien et getOrien
        Point2D.Double vOrientation=new Point2D.Double(30,30);
        double norme = Geom.magnitude(ship.getOrien());
        vOrientation=Geom.normalize(vOrientation, norme);
        ship.setOrien(vOrientation);
        assertTrue("setOrien(v) et getOrien()", vOrientation.equals(ship.getOrien()));
        
        //Test setSpeed et getSpeed
        ship.setSpeed(30);
        assertTrue("setSpeed(i) et getSpeed()", (30 == ship.getSpeed()));
        
        //Test setAcceleration et getAcceleration
        ship.setAcceleration(30);
        assertTrue("setAcceleration(i) et getAcceleration()", (30 == ship.getAcceleration()));
        
        /*test du Canon
        les tests du vecteur entre la souris et le vaisseau (pour orienter le canon) sont testés dans testGeom, ainsi que les tests de la fonction angle.
        pour la jauge de température, un simple increase/decrease est utilisé.*/
        
    } 
            
    /**
     * Ensemble de test pour la classe <code>Geom</code>.
     */
    @Test
    public static void testGeom()
    {        
    
        //Génère un vecteur avec 2 points aléatoirement
        Point2D.Double p1_random= Geom.pointRandom(1,1);
        Point2D.Double p2_random= Geom.pointRandom(1,1);
        
        //Génère un vecteur avec 2 points
        Point2D.Double v1_random= Geom.vector(p1_random,p2_random);        
        Point2D.Double v2_random=Geom.vector(p2_random,p1_random);

        //Génère un vecteur avec les points (1,1) et (2,2)
        Point2D.Double p1= new Point2D.Double(1,1);
        Point2D.Double p2= new Point2D.Double(2,2);
        assertTrue("Geom.vector(p1,p2)", (Geom.vector(p1,p2).getX() == 1 && Geom.vector(p1,p2).getY()==1));

        //Test de la somme de 2 vecteurs
        assertTrue("Geom.add(p1,p2)", (Geom.add(p1, p2).getX()==3 && Geom.add(p1, p2).getY()==3));
            
        //Test de la distance euclidienne
        assertTrue("Geom.distance(p1,p2)", (Geom.distance(p1,p2)==Math.sqrt(2) && Geom.distance(p2,p1)==Math.sqrt(2) && Geom.distance(p1,p1)==0));
        
        //Test de la méthode magnitude
        Point2D.Double v1_1 = new Point2D.Double(1,1);
        Point2D.Double v1_0 = new Point2D.Double(1,0);
        Point2D.Double v10_0 = new Point2D.Double(10,0);
        assertTrue("Geom.magnitude(v)", (((Geom.magnitude(v1_1)==Math.sqrt(2) && (Geom.magnitude(v1_0)==1)&&(Geom.magnitude(v10_0)==10)))));
            
        //Test de la norme de la fonction normalize    
        assertTrue("Geom.normalize(v): Test1", (Math.sqrt(Math.pow(Geom.normalize(v1_1).getX(),2)+Math.pow(Geom.normalize(v1_1).getY(),2))-1<Geom.EPSILON));
        
        assertTrue("Geom.normalize(v,n): Test2", (Math.sqrt(Math.pow(Geom.normalize(v1_1,5).getX(),2)+Math.pow(Geom.normalize(v1_1,5).getY(),2))-5<Geom.EPSILON));
        
        assertTrue("Geom.normalize(v): Test3", (Math.sqrt(Math.pow(Geom.normalize(v1_1).getX(),2)+Math.pow(Geom.normalize(v1_1).getY(),2))-1<Geom.EPSILON));
        
        assertTrue("Geom.normalize(v,n): Test4", (Math.sqrt(Math.pow(Geom.normalize(v1_0).getX(),2)+Math.pow(Geom.normalize(v1_0).getY(),2))-5<Geom.EPSILON));
        
        assertTrue("Geom.normalize(v): Test 5", (Math.sqrt(Math.pow(Geom.normalize(v10_0).getX(),2)+Math.pow(Geom.normalize(v10_0).getY(),2))-1<Geom.EPSILON));
        
        assertTrue("geom.normalize(v,n): Test 6", (Math.sqrt(Math.pow(Geom.normalize(v10_0).getX(),2)+Math.pow(Geom.normalize(v10_0).getY(),2))-5<Geom.EPSILON ));
            

        //Test de angle
        Point2D.Double v1= new Point2D.Double(1,1);
        Point2D.Double v2= new Point2D.Double(1,0);
        Point2D.Double v3= new Point2D.Double(0,1);
        Point2D.Double v4= new Point2D.Double(1,-1);
        Point2D.Double v5= new Point2D.Double(0,-1);
        Point2D.Double v6= new Point2D.Double(-1,-1);
        



        assertEquals(45, Geom.angle(v1), Geom.EPSILON);
        assertEquals(0, Geom.angle(v2), Geom.EPSILON);
        assertEquals(90, Geom.angle(v3), Geom.EPSILON);
        assertEquals(315, Geom.angle(v4), Geom.EPSILON);
        assertEquals(270, Geom.angle(v5), Geom.EPSILON);
        assertEquals(225, Geom.angle(v6), Geom.EPSILON);
        
        //Angle entre 2 vecteurs   

        assertEquals(-45, Geom.angle(v1, v2), Geom.EPSILON);
        assertEquals(45, Geom.angle(v2, v1), Geom.EPSILON);
        assertEquals(0, Geom.angle(v1, v1), Geom.EPSILON);
        assertEquals(45, Geom.angle(v1, v3), Geom.EPSILON);
        assertEquals(-45, Geom.angle(v3, v1), Geom.EPSILON);
        assertEquals(-135, Geom.angle(v2, v6), Geom.EPSILON);
        assertEquals(135, Geom.angle(v6, v2), Geom.EPSILON);
        assertEquals(-135, Geom.angle(v1, v5), Geom.EPSILON);

        
        //Rotation d'un vecteur
        assertTrue("Geom.rotate(v,angle): Test 1", (Math.abs(Geom.rotate(v1,-45).getX()-Math.sqrt(2))<Geom.EPSILON && Math.abs(Geom.rotate(v1,-45).getY()) <Geom.EPSILON));
        
        Point2D.Double vTestrotat = Geom.normalize(Geom.rotate(v1,45)); // rotation à -45°
        assertTrue("Geom.rotate(v,angle): Test 2", (vTestrotat.getX()<Geom.EPSILON && Math.abs(vTestrotat.getY()-1)<Geom.EPSILON));
        
        //Rotation d'un vecteur et d'un point
        vTestrotat = Geom.rotate(v1,v3,45); // rotation à -45°
        assertTrue("Geom.rotate(v1,v2,angle): Test 3", ( Math.abs(vTestrotat.getX() + 1) < Geom.EPSILON && Math.abs(vTestrotat.getY()- Math.sqrt(2)) < Geom.EPSILON));
        
        //Génère un vecteur aleatoirement
        assertTrue("Geom.vectorRandom(n)", (Math.abs(Geom.magnitude(Geom.vectorRandom(1))-1) <= Geom.EPSILON));
        
        //Génère un point aléatoirement sur un des bords
        Point2D.Double pBorder = Geom.pointRandomBorder(100,100);
        assertTrue("Geom.pointRandomBorder(x,y)", (pBorder.getX() <= 100 && pBorder.getY() <= 100));
        
        // Test de l'intersection de 2 cercles
        assertTrue("Geom.isInterTwoCircles 2 cercles égaux", Geom.isInterTwoCircles(new Point2D.Double(1,1), 4, new Point2D.Double(1,1), 4));  
        
        assertTrue("Geom.isInterTwoCircles 2 centre égaux, Radius different > cercle à l'interieur", Geom.isInterTwoCircles(new Point2D.Double(1,1), 3, new Point2D.Double(1,1), 4));   
        
        assertTrue("Geom.isInterTwoCircles centres à l'interrieure des cercles > cercle à l'interieur", Geom.isInterTwoCircles(new Point2D.Double(0,0), 3, new Point2D.Double(0,2), 6));        
        
        assertTrue("Geom.isInterTwoCircles centres à l'interrieure des cercles, une intersection", Geom.isInterTwoCircles(new Point2D.Double(0,0), 3, new Point2D.Double(0,3), 6));
        
        assertTrue("Geom.isInterTwoCircles centres à l'interrieure des cercles, 2 intersection", Geom.isInterTwoCircles(new Point2D.Double(0,0), 3, new Point2D.Double(0,3), 4));        
        
        assertTrue("Geom.isInterTwoCircles centres à l'exterieur des cercles, 0 intersection", !Geom.isInterTwoCircles(new Point2D.Double(0,0), 3, new Point2D.Double(0,8), 4));              
        
        assertTrue("Geom.isInterTwoCircles centres à l'exterieur des cercles, 1 intersection", Geom.isInterTwoCircles(new Point2D.Double(0,0), 4, new Point2D.Double(0,8), 4));   
        
        assertTrue("Geom.isInterTwoCircles centres à l'exterieur des cercles, 2 intersections", Geom.isInterTwoCircles(new Point2D.Double(0,0), 5, new Point2D.Double(0,8), 4));              
        
        
        //Test de frameModulo
        Point2D.Double pPosModulo = new Point2D.Double(120,120);
        Point2D.Double pPosModulo1 = new Point2D.Double(20,20);
        assertTrue("frameModulo(p,v,x,y)", (Geom.frameModulo(pPosModulo, new Point2D.Double(0,0),100,100).equals(pPosModulo1)));
        
        //Test de isCloseOrInBorder
        Point2D.Double p = new Point2D.Double(120,120);
        assertTrue("isCloseOrInBorder(p,d,x,y) 1", Geom.isCloseOrInBorder(p, 21, 100, 100));
        assertTrue("isCloseOrInBorder(p,d,x,y) 2", Geom.isCloseOrInBorder(p, 20, 100, 100));
        assertTrue("isCloseOrInBorder(p,d,x,y) 3", !Geom.isCloseOrInBorder(p, 19, 100, 100));
        assertTrue( "isCloseOrInBorder(p,x,y) 1", !Geom.isCloseOrInBorder(p, 100, 100));
        p = new Point2D.Double(50,50);
        assertTrue("isCloseOrInBorder(p,x,y) 2", Geom.isCloseOrInBorder(p, 100, 100));
        
    }
}